UNIT KToolReg;
{+H
---------------------------------------------------------------------------
  File        - KTOOLREG.PAS
  Purpose     - Provides a registration unit for KTools.
  Author      - Keith S. Brown
  Reference   - source by Borland Int, etc.
  Revised     - 1998.0218 (KSB) Wrote first working version (for TKNavigator).
---------------------------------------------------------------------------}
INTERFACE

{}PROCEDURE Register;

              {=================================================}
IMPLEMENTATION
USES
  DsgnIntf, EditIntf, ExptIntf, ToolIntf, Classes,  Controls, Forms,
  DB,       DBTables, Dialogs,  SysUtils, KNavigat, KomboBox, NKolCBox,
  NKolEdit;



TYPE
  TNDataSetProperty= CLASS(TComponentProperty)
  PRIVATE
   FCheckProc : TGetStrProc;
   PROCEDURE    CheckComponent(CONST Value: STRING);
  PUBLIC
    FUNCTION    GetAttributes: TPropertyAttributes; OVERRIDE;
    PROCEDURE   GetValues(Proc: TGetStrProc); OVERRIDE;
    PROCEDURE   SetValue(CONST Value :STRING); OVERRIDE;
  END {CLASS};


{}FUNCTION    TNDataSetProperty.GetAttributes: TPropertyAttributes;
  BEGIN
    Result := INHERITED GetAttributes + [paValueList, paSortList];
{}END {GetAttributes};




{}PROCEDURE   TNDataSetProperty.CheckComponent(CONST Value:STRING);
  VAR
    liJ       : INTEGER;
    loDataSet : TDataset;
  BEGIN
    loDataSet := TDataset(Designer.GetComponent(Value));
    FOR liJ := 0 TO PropCount - 1 DO BEGIN
      IF TDataSource(GetComponent(liJ)).IsLinkedTo(loDataSet) THEN BEGIN
        Exit; { Don't list if already linked. }
      END {IF};
    END {FOR};

    FCheckProc(Value);	{Add this component.}
{}END {CheckComponent};




{}PROCEDURE   TNDataSetProperty.GetValues(Proc: TGetStrProc);
  BEGIN
    FCheckProc := Proc;		{ Save real "add value" proc. }
    INHERITED GetValues(CheckComponent); { Let inherited property editor enumerate classes. We'll filter with CheckComponent.}
{}END {GetValues};




{}PROCEDURE   TNDataSetProperty.SetValue(CONST Value : STRING);
  VAR
    loDataSet : TDataSet;
  BEGIN
    loDataSet := TDataSet(Designer.GetComponent(Value));
    SetOrdValue(LongINT(loDataSet));
{}END {SetValue};




{}PROCEDURE Register;
  BEGIN
    RegisterComponents('KTools',[TKNavigator]);
    RegisterPropertyEditor(TypeInfo(TDataSet), TKNavigator, 'DataSet', TNDataSetProperty);
    RegisterComponents('KTools', [TKomboBox]);
    RegisterPropertyEditor(TypeInfo(TKomboBoxAboutProperty), TKomboBox, 'ABOUT', TKomboBoxAboutProperty);
    RegisterComponents('KTools', [TNKolumnComboBox]);
    RegisterPropertyEditor(TypeInfo(TObject), TNKolumnComboBox, 'ABOUT', TNKolComboBoxAboutProperty);
    RegisterPropertyEditor(TypeInfo(TColumnInfo), TNKolumnComboBox, 'Columns', TNColumnProperty);
{}END {Register};



END {KTOOLREG}.
