UNIT NKolEdit;
INTERFACE
USES
  Windows,  Messages, SysUtils, Classes,  Graphics, Controls, Forms,
  Dialogs,  StdCtrls, Buttons,  ExtCtrls, DsgnIntf, NKolCBox;



TYPE
  TNKolComboBoxAboutProperty = CLASS(TPropertyEditor)
  PRIVATE
    PROCEDURE   Edit; OVERRIDE;
    FUNCTION    GetAttributes: TPropertyAttributes; OVERRIDE;
    FUNCTION    GetValue: STRING; OVERRIDE;
  END {CLASS};

  TNColumnProperty = CLASS(TPropertyEditor)
    FUNCTION    GetAttributes:TPropertyAttributes; OVERRIDE;
    FUNCTION    GetValue:STRING; OVERRIDE;
    PROCEDURE   Edit; OVERRIDE;
  END {CLASS};


  TEditColumnInfoDlg    = CLASS(TForm)
    OkBtn     : TBitBtn;
    CancelBtn : TBitBtn;
    Panel1    : TPanel;
    Label1    : TLabel;
    Label2    : TLabel;
    Label3    : TLabel;
    GroupBox1 : TGroupBox;
    Memo1     : TMemo;
    ColumnText: TMemo;
    Edit1     : TEdit;
  PRIVATE
    { Private declarations }
    PROCEDURE   PutColumnInfo(aInfo:TColumnInfo);
    PROCEDURE   GetColumnInfo(aInfo:TColumnInfo);
  PUBLIC
    { Public declarations }
  END {CLASS};


              {=================================================}
IMPLEMENTATION
{$R *.DFM}



{}PROCEDURE   TEditColumnInfoDlg.GetColumnInfo(aInfo:TColumnInfo);
  BEGIN
    columnText.Lines.Clear;
    columnText.Lines.Assign(aInfo.Columns);
{}END {GetColumnInfo};




{}PROCEDURE   TEditColumnInfoDlg.PutColumnInfo(aInfo:TColumnInfo);
  BEGIN
    aInfo.Columns.Clear;
    aInfo.Columns.Assign(columnText.Lines);
{}END {PutColumnInfo};




{}FUNCTION    EditColumnInfo(aColInfo:TColumnInfo; aCaption:STRING):BOOLEAN;
  VAR
    loDlg     : TEditColumnInfoDlg;
  BEGIN
    result := FALSE;
    loDlg := TEditColumnInfoDlg.Create(application);
    TRY
      loDlg.Caption := aCaption+loDlg.Caption;
      loDlg.GetColumnInfo(aColInfo);
      result := loDlg.ShowModal = mrOk;
      IF result THEN BEGIN
        loDlg.PutColumnInfo(aColInfo);
      END {IF};
    FINALLY
      loDlg.Free;
    END {TRY};
{}END {EditColumnInfo};




{}FUNCTION    TNColumnProperty.GetAttributes:TPropertyAttributes;
  BEGIN
    result := [paDialog];
{}END {GetAttributes};




{}FUNCTION    TNColumnProperty.GetValue:STRING;
  BEGIN
    result := Format('(%s)',[GetPropType^.Name]);
{}END {GetValue};




{}PROCEDURE   TNColumnProperty.Edit;
  VAR
    loInfo    : TColumnInfo;
    ls        : STRING;
  BEGIN
    loInfo := TColumnInfo(GetOrdValue);
    ls := TComponent(GetComponent(0)).Owner.Name+'.'+TComponent(GetComponent(0)).Name+'.'+GetName+' - ';
    IF EditColumnInfo(loInfo,ls) THEN BEGIN
      SetOrdValue(LongINT(loInfo));
    END {IF};
{}END {Edit};


{ TNKolComboBoxAboutProperty }


{}PROCEDURE   TNKolComboBoxAboutProperty.Edit;
  BEGIN
    Application.MessageBox
      ('Freeware (Copyright 1998) By Keith Brown'#13
      +'Multi-Column ComboBox with auto-completion'#13
      +'E-Mail: keith_brown@juno.com'
      ,'TNKolumnComboBox version 1.0.0',MB_OK+ MB_ICONINFORMATION);
{}END {Edit};




{}FUNCTION    TNKolComboBoxAboutProperty.GetAttributes: TPropertyAttributes;
  BEGIN
    GetAttributes:=[paDialog, paReadOnly];
{}END {GetAttributes};




{}FUNCTION    TNKolComboBoxAboutProperty.GetValue: STRING;
  BEGIN
    GetValue:='(About)';
{}END {GetValue};


END {TabEdit}.
